const scanner = new Html5Qrcode("reader");

function getCheckpointCoords() {
    navigator.geolocation.getCurrentPosition(setCheckpointCoords);
}

function setCheckpointCoords(position) {
    $("[name='lat']").val(position.coords.latitude);
    $("[name='lon']").val(position.coords.longitude);

    window.setTimeout(function() {
        navigator.geolocation.getCurrentPosition(setCheckpointCoords);
    }, 3000);
}

function onScanSuccess(decodedText, decodedResult) {
    scanner.stop();
    $("[name='username']").val(decodedText);
    $("[name='username']").closest("form").submit();
}

function onScanError(error) {
    console.warn(`Code scan error: ${error}`);
}

$(document).ready(function($) {
    if (navigator.geolocation) {
        getCheckpointCoords();
    }

    let cameraConfig = { facingMode: "environment" };
    let scannerConfig = { fps: 10, qrbox: {width: 250, height: 250} };

    scanner.start(cameraConfig, scannerConfig, onScanSuccess);
});
